#include <iostream>
#include <cmath>
using namespace std;

int nullstellen(double p, double q, double& x1, double& x2) {
  double d = p * p / 4 - q;
  if (d < 0) return 0;  // keine Lösung
  if (d == 0) {
    x1 = -p / 2;
    return 1;           // 1 Lösung
  }
  x1 = -p / 2 - sqrt(d);
  x2 = -p / 2 + sqrt(d);
  return 2;             // 2 Lösungen
}

int main()
{
	double x1, x2;
	int loesungen;
	loesungen = nullstellen(-4, 3, x1, x2);
	switch (loesungen) {
	case 0: cout << "keine Nullstellen" << endl; break;
	case 1: cout << "1 Nullstelle: " << x1 << endl; break;
	case 2: cout << "2 Nullstellen: " << x1 << ", " << x2 << endl; break;
	}
}
