#include <iostream>
#include <cctype>
using namespace std;

enum TokenT { D, OP, IS, WS, ERR };
int GetState[][4] = {
	{  1, -1, -1,  0 },
	{  1,  0,  2,  3 },
	{  2,  2,  2,  2 },
	{ -1,  0,  2,  3 }
};

bool isbinop(char c) {
	return c == '+' || c == '-' || c == '*' || c == '/';
}

bool akzeptor(char const* input) {
	int state = 0;
	while (*input != '\0' && state != -1) {
		cout << state << " ";
		char s = *input++;
		TokenT token = ERR;
		if (isdigit(s)) token = D;
		if (isbinop(s)) token = OP;
		if (s == '=')   token = IS;
		if (isspace(s)) token = WS;
		state = (token == ERR) ? -1 : GetState[state][token];
	}
	cout << state << endl;
	return (state == 2);
}

int main()
{
	char const *s = "3+ 4 - 5=";
	bool akzeptiert = akzeptor(s);
	if (akzeptiert) cout << "'" << s << "' akzeptiert" << endl;
	else cout << "'" << s << "' nicht akzeptiert" << endl;
}
