#include <iostream>
using namespace std;

template <typename T>
int imin(unsigned int const n, T a[]) {
	// leeres Array?
	if (n == 0) return -1;
	// Array hat also mindestens 1 Element!
	int i, imin = 0;
	for (i = 1; i < n; i++)
		if (a[i] < a[imin]) imin = i;
	return imin;
}

template <typename T>
void sortiere(unsigned int const n, T a[]) {
	int i, k;
	for (k = n - 1; k > 1; k--) { 
		i = imin<T>(k - 1, a);
		if (a[i] < a[k]) swap<T>(a[i], a[k]);    
	}
}

template <typename T>
void swap(T &a, T &b) {
	T h = a; a = b; b = h;
}

template <typename T>
void zeigean(unsigned int const n, T a[]) {
	for (unsigned i = 0; i < n; ++i) {
		cout << a[i] << " ";
	}
	cout << endl;
}

int main()
{
	int zahlen[] = { 4, 9, 42, 3, 8 };
	zeigean(5, zahlen);
	sortiere(5, zahlen);
	zeigean(5, zahlen);
}
